import LogicFlow from "@logicflow/core";
import { Group, DndPanel, BpmnElement } from "@logicflow/extension";
import customEdge from "./customEdge";
import setDndPanel from "../020_contextPad/setDndPanel";

(function ($) {
  function workflow(configuration) {
    const lf = new LogicFlow(configuration);

    lf.register(customEdge);
    lf.setDefaultEdgeType("custom-edge");
    setDndPanel(lf);
    lf.render(configuration.data);

    document.querySelector("#js_set_animate").addEventListener("click", () => {
      const { edges } = lf.getGraphRawData();
      edges.forEach(({ id }) => {
        lf.openEdgeAnimation(id);
      });
    });
  }

  Drupal.behaviors.workflow = {
    attach: function (context, settings) {
      $('.workflow-editor').once().each(function (selector) {
        let configuration = {
          container: document.querySelector('#'+$(this).data('id')),
          width: 700,
          height: 600,
          grid: true,
          plugins: [Group, DndPanel, BpmnElement],
          edgeGenerator: (sourceNode, targetNode, currentEdge) => {
            if (sourceNode.type === "circle") {
              return "line";
            }
          }
        };
        workflow(configuration);
      });
      $('.workflow-display').once().each(function (selector) {
        let configuration = {
          container: document.querySelector('#'+$(this).data('id')),
          width: 700,
          height: 600,
        };
        configuration.data = drupalSettings.json_workflow[$(this).data('id')];

        workflow(configuration);
      });
    }
  };

})(jQuery);
